设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 2182|回复: 10

[工具] 增强拉伸

[复制链接]

已领礼包: 1262个

财富等级: 财源广进

发表于 2014-11-4 20:51:56 | 显示全部楼层 |阅读模式
  • 插件名称 : 增强拉伸(可拉伸图块)
  • 作  者 : st788796
  • 运行环境 :XDRX API 
  • 发布时间 :2014-11-04
  • 命令名称 :XDTB_Stretch
  • 插件介绍 :增强拉伸
  • 备  注 : (点击图片可以放大)
(点击图片可以放大)

晓东温馨提示 1、运行环境为 晓东工具箱XDRX API 的插件,请下载最新版本的 晓东工具箱XDRX API开发环境 一键安装
2、在ACAD中如何加载插件,请看 论坛插件使用方法
3、如果您有要求需要定制插件,请到 编程申请 论坛发帖求助

插件详细内容

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
  1. (defun c:XDTB_Stretch (/ p pts ss p1)
  2.   (if (and (setq pts (xd::doc:getpolygon nil nil 1))
  3.            (setq ss (ssget "CP" pts))
  4.            (setq p1 (getpoint (car pts) "\n方向: "))
  5.            (setq v (mapcar '- p1 (car pts)))
  6.       )
  7.     (progn
  8.       (xdrx_entity_stretch ss pts v)
  9.       (if (setq ss (ssget "F" pts '((0 . "INSERT"))))
  10.         (mapcar        '(lambda (x)
  11.                    (xdrx_entity_stretch x pts v)
  12.                  )
  13.                 (xdrx_pickset->ents ss)
  14.         )
  15.       )
  16.     )
  17.   )
  18.   (princ)
  19. )
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 40个

财富等级: 招财进宝

发表于 2014-11-4 21:15:36 | 显示全部楼层
只用 (mapcar        '(lambda (x)
                   (xdrx_entity_stretch x pts v)
                 )
                (xdrx_pickset->ents ss)
        )

是不是可以不用IF了,图块和实体一样处理?
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 1262个

财富等级: 财源广进

 楼主| 发表于 2014-11-4 21:27:10 | 显示全部楼层
newer 发表于 2014-11-4 21:15
只用 (mapcar        '(lambda (x)
                   (xdrx_entity_stretch x pts v)
                 ...

是可以这样用,简化代码,只是觉得只有线上 Insert 才需要单独 Stretch,前面直接用选集处理就都在 ARX 内部减少了交互

点评

拉伸不会很很多实体吧,还是代码简化应该第一位的吧。  详情 回复 发表于 2014-11-4 21:40
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 40个

财富等级: 招财进宝

发表于 2014-11-4 21:40:55 | 显示全部楼层
本帖最后由 newer 于 2014-11-4 21:42 编辑
st788796 发表于 2014-11-4 21:27
是可以这样用,简化代码,只是觉得只有线上 Insert 才需要单独 Stretch,前面直接用选集处理就都在 ARX  ...

拉伸不会很很多实体吧,还是代码简化应该第一位的吧。
另外,为什么块要单独呢,不能放选择集里面,一起拉伸吗? 找老大去。

点评

不让选择集方式有块的原因是因为怕你一次不小心选择了2个以上的同名的块,这样操作就此起彼伏了,争相更新了。 不过你提醒我了,我看看从代码上能规避不。  详情 回复 发表于 2014-11-4 21:59
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 145个

财富等级: 日进斗金

发表于 2014-11-4 21:59:53 | 显示全部楼层
newer 发表于 2014-11-4 21:40
拉伸不会很很多实体吧,还是代码简化应该第一位的吧。
另外,为什么块要单独呢,不能放选 ...

不让选择集方式有块的原因是因为怕你一次不小心选择了2个以上的同名的块,这样操作就此起彼伏了,争相更新了。
不过你提醒我了,我看看从代码上能规避不。

点评

拉伸的是定义,更新的是引用,线上有同名块时所框住的范围可能不同,以哪个为准呢? F 后同名的应该只拉一个  详情 回复 发表于 2014-11-4 23:19
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 264个

财富等级: 日进斗金

发表于 2014-11-4 23:19:56 来自手机 | 显示全部楼层
本帖最后由 iLisp 于 2014-11-4 23:21 编辑
XDSoft 发表于 2014-11-4 21:59
不让选择集方式有块的原因是因为怕你一次不小心选择了2个以上的同名的块,这样操作就此起彼伏了,争相更 ...


拉伸的是定义,更新的是引用,线上有同名块时所框住的范围可能不同,以哪个为准呢?
F 后同名的应该只拉一个,而且是相交区域最大的那个
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 1262个

财富等级: 财源广进

 楼主| 发表于 2014-11-5 09:21:39 | 显示全部楼层
API更新后更强悍了,因为扫到的 BlockRef  会修改 BlockDef ,慎用!
  1. (defun c:XDTB_Stretch (/  pts ss v)
  2.   (if (and (setq pts (xd::doc:getpolygon nil nil 1))
  3.            (setq ss (ssget "CP" pts))
  4.            (setq v (xd::doc:getdist nil "\n距离: " nil nil nil))
  5.       )
  6.     (xdrx_entity_stretch ss pts v)
  7.   )
  8.   (princ)
  9. )
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2014-12-22 21:55:19 | 显示全部楼层
哇。。。。。。。。。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

发表于 2018-10-30 15:56:20 | 显示全部楼层
本帖最后由 Feverpitch 于 2018-10-30 15:57 编辑

请问一下s大,我在cad2014中安装了最新的晓东工具箱(18-10-23版本),使用里面的增强拉伸功能,发现图块拉不动,普通的矩形可以拉动,可能是什么原因呢?
多谢!
Animation.gif
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 22个

财富等级: 恭喜发财

发表于 2018-11-15 06:36:46 | 显示全部楼层
能否增加一个矩形框选的方式?
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 5565个

财富等级: 富甲天下

发表于 2018-11-15 08:58:01 | 显示全部楼层
不让选择集方式有块的原因是因为怕你一次不小心选择了2个以上的同名的块,这样操作就此起彼伏了,争相更新了。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2021-3-8 01:19 , Processed in 0.186067 second(s), 43 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表